//        
//          

unit SpRecordLibTypesW;

interface

uses Windows;

//     
const
  SPR_CHANNEL_HARDNAME                 = $00000001;
  SPR_CHANNEL_USERNAME                 = $00000002;
  SPR_CHANNEL_EXCLUSIVE                = $00000004;

//   
const
  SPR_E_BASE                           = $80040200;
  SPR_S_BASE                           = $00040200;

  SPR_S_OK                             = $00000000;
  SPR_S_FALSE                          = $00000001;

  SPR_S_CONNECTIONNOTFOUND             = LongInt(SPR_S_BASE + $0001);
  SPR_S_WAITDISCONNECTTIMEOUT          = LongInt(SPR_S_BASE + $0002);
  SPR_S_WAIT_TIMEOUT                   = LongInt(SPR_S_BASE + $0003);

  SPR_E_ACCESS_DENIED                  = LongInt(SPR_E_BASE + $1001);
  SPR_E_CONNECT_LIMIT                  = LongInt(SPR_E_BASE + $1002);
  SPR_E_NOTFOUNDCHANNELNAME            = LongInt(SPR_E_BASE + $1003);
  SPR_E_SOCKETOPEN                     = LongInt(SPR_E_BASE + $1004);
  SPR_E_WAIT_FAILED                    = LongInt(SPR_E_BASE + $1005);
  SPR_E_CLIENTSOCKETOPEN               = LongInt(SPR_E_BASE + $1006);
  SPR_E_NOCONNECT                      = LongInt(SPR_E_BASE + $1007);
  SPR_E_INSUFFICIENT_BUFFER            = LongInt(SPR_E_BASE + $1008);
  SPR_E_NOMEMORY                       = LongInt(SPR_E_BASE + $1009);

  SPR_E_UNKNOWNCMD                     = LongInt(SPR_E_BASE + $100A);
  SPR_E_NOTSUPPORT                     = LongInt(SPR_E_BASE + $100B);
  SPR_E_INVALIDNUMBER                  = LongInt(SPR_E_BASE + $100C);
  SPR_E_ALREADYUSE                     = LongInt(SPR_E_BASE + $100D);
  SPR_E_INEXCLUSIVEMODE                = LongInt(SPR_E_BASE + $100E);
  SPR_E_NUMBERISDIALING                = LongInt(SPR_E_BASE + $100F);
  SPR_E_CMDWAITERROR                   = LongInt(SPR_E_BASE + $1010);
  SPR_E_LIBVERSION                     = LongInt(SPR_E_BASE + $1011);
  SPR_E_OUTPUTMODEALREADYUSE           = LongInt(SPR_E_BASE + $1012);
  SPR_E_NOTINOUTPUTMODE                = LongInt(SPR_E_BASE + $1013);
  SPR_E_HANDSETTAKENOTHERUSER          = LongInt(SPR_E_BASE + $1014);
  SPR_E_HANDSETNOTTAKE                 = LongInt(SPR_E_BASE + $1015);
  SPR_E_NOTWRITING                     = LongInt(SPR_E_BASE + $1016);
  SPR_E_USEEVENTOBJECT                 = LongInt(SPR_E_BASE + $1017);
  SPR_E_DEVICENOTUSE                   = LongInt(SPR_E_BASE + $1018);
  SPR_E_CHANNELNOTUSE                  = LongInt(SPR_E_BASE + $1019);
  SPR_E_NOTFOUNDDEVICENAME             = LongInt(SPR_E_BASE + $101A);
  SPR_E_NORECORDDETECT                 = LongInt(SPR_E_BASE + $101B);
  SPR_E_ALREADYWRITEAUTO               = LongInt(SPR_E_BASE + $101C);
  SPR_E_ALREADYWRITEUSER               = LongInt(SPR_E_BASE + $101D);
  SPR_E_NOTYOURWRITING                 = LongInt(SPR_E_BASE + $101E);
  SPR_E_VOICEMAILWORKING               = LongInt(SPR_E_BASE + $101F);
  SPR_E_SENDCMDPARAM                   = LongInt(SPR_E_BASE + $1020);
  SPR_E_SPRECORDPRGNOTFOUND            = LongInt(SPR_E_BASE + $1021);
  SPR_E_USERNAMEORPASSWORD             = LongInt(SPR_E_BASE + $1022);
  SPR_E_NOCONVERSATION                 = LongInt(SPR_E_BASE + $1023);
  SPR_E_NORING                         = LongInt(SPR_E_BASE + $1024);

  SPR_E_UNKNOWNERROR                   = LongInt(SPR_E_BASE + $1100);
  SPR_E_INVALIDARG                     = LongInt($80070057);

//     
const
  SPR_DEVICE_SUPPORT_LINESTATE = $00000001;
  SPR_DEVICE_SUPPORT_VOICEMAIL = $00000002;
  SPR_DEVICE_SUPPORT_ISDNBRI   = $00000004;
  SPR_DEVICE_SUPPORT_ISDN      = $00000008;
  SPR_DEVICE_SUPPORT_DIGITAL   = $00000010;

//      
const
  SPR_AUDIODATA_BEGIN = $00000001;
  SPR_AUDIODATA_END   = $00000002;

//   
const
  DIAL_PULSE = $00000001;
  DIAL_TONE  = $00000002;

const
//    
  SPR_MSG_RECORD_START                         = $00000001;
  SPR_MSG_RING                                 = $00000002;
  SPR_MSG_ANI_DETECT                           = $00000003;
  SPR_MSG_RECORD_TYPE                          = $00000004;
  SPR_MSG_DIALLED_PHONE                        = $00000005;
  SPR_MSG_MISSED_PHONE                         = $00000006;
  SPR_MSG_RECORD_STOP                          = $00000007;
  SPR_MSG_DEVICE_CONNECTED                     = $00000008;
  SPR_MSG_DEVICE_DISCONNECTED                  = $00000009;
  SPR_MSG_CONVERSATION_BEGIN                   = $0000000A;
  SPR_MSG_CONVERSATION_END                     = $0000000B;
  SPR_MSG_COMPRESSING_FINISHED                 = $0000000C;
  SPR_MSG_FAX_DETECTED                         = $0000000D;

//    
  SPR_MSG_C_RECORD_START                       = $00008001;
  SPR_MSG_C_RING                               = $00008002;
  SPR_MSG_C_ANI_DETECT                         = $00008003;
  SPR_MSG_C_RECORD_TYPE                        = $00008004;
  SPR_MSG_C_DIALLED_PHONE                      = $00008005;
  SPR_MSG_C_MISSED_PHONE                       = $00008006;
  SPR_MSG_C_RECORD_STOP                        = $00008007;

  SPR_MSG_C_AUDIODATA                          = $00008008;
  SPR_MSG_C_DIALINGISCOMPLETED                 = $00008009;
  SPR_MSG_C_DTMF                               = $0000800A;
  SPR_MSG_C_LINEBUSY                           = $0000800B;
  SPR_MSG_C_AUDIOBUFSTATE                      = $0000800C;
  SPR_MSG_C_LINEOFF                            = $0000800D;
  SPR_MSG_C_LINEON                             = $0000800E;
  SPR_MSG_C_HANDSETOFF                         = $0000800F;
  SPR_MSG_C_HANDSETON                          = $00008010;
  SPR_MSG_C_TARGETTAKENHANDSET                 = $00008011;
  SPR_MSG_C_CONVERSATION_BEGIN                 = $00008012;
  SPR_MSG_C_CONVERSATION_END                   = $00008013;
  SPR_MSG_C_PHONEHANDSETON                     = $00008014;
  SPR_MSG_C_CALLSENDINGCONTROL                 = $00008015;
  SPR_MSG_C_FILECREATEERROR                    = $00008016;
  SPR_MSG_C_CARRIER                            = $00008017;
  SPR_MSG_C_FAX_DETECTED                       = $00008018;

//  
  SPR_MSG_CHANGE_CHANNEL_NAME                  = $00010001;
  SPR_MSG_TEXT                                 = $00010002;
  SPR_MSG_POWERSUSPEND                         = $00010003;
  SPR_MSG_DESTROY_CONNECTION                   = $000100FF;

//    TMSGDestroyConnection.dwDestroyReason
const
  SPR_DR_PROGRAM_EXIT    = $00;
  SPR_DR_DISABLED        = $01;
  SPR_DR_CONNECTIONERROR = $02;
  SPR_DR_SWITCHEDOFF     = $03;
  SPR_DR_DEVICEERROR     = $04;
  SPR_DR_UNKNOWN         = $FF;

//  
const
  SPR_RT_UNKNOWN         = $0000;
  SPR_RT_RECEIVED        = $0001;
  SPR_RT_DIALLED         = $0002;
  SPR_RT_MISSED          = $0004;
  SPR_RT_BYLEVEL         = $0008;
  SPR_RT_BYCOMMAND       = $0010;
  SPR_RT_VOICEMAIL       = $0020;
//  SPR_RT_FRAGMENT        = $0040;

// DTMF - 
const
  SPR_DTMF_0       = $00;
  SPR_DTMF_1       = $01;
  SPR_DTMF_2       = $02;
  SPR_DTMF_3       = $03;
  SPR_DTMF_4       = $04;
  SPR_DTMF_5       = $05;
  SPR_DTMF_6       = $06;
  SPR_DTMF_7       = $07;
  SPR_DTMF_8       = $08;
  SPR_DTMF_9       = $09;
  SPR_DTMF_STAR    = $0A;
  SPR_DTMF_POUND   = $0B;
  SPR_DTMF_A       = $0C;
  SPR_DTMF_B       = $0D;
  SPR_DTMF_C       = $0E;
  SPR_DTMF_D       = $0F;
  SPR_DTMF_UNKNOWN = $FF;

// InfoIndex  ISpRecordChannelClientW.GetInfo
const
  SPR_CHANNEL_INFO_CONVERSATIONACTIVE             = $00000001; // WordBool
  SPR_CHANNEL_INFO_CONVERSATIONDATETIME           = $00000002; // DateTime
  SPR_CHANNEL_INFO_CONVERSATIONLENG               = $00000003; // LONG
  SPR_CHANNEL_INFO_RECORDACTIVE                   = $00000004; // WordBool
  SPR_CHANNEL_INFO_RECORDDATETIME                 = $00000005; // DateTime
  SPR_CHANNEL_INFO_RECORDLENG                     = $00000006; // LONG
  SPR_CHANNEL_INFO_PHONEFROM                      = $00000007; // BSTR
  SPR_CHANNEL_INFO_SUBPHONEFROM                   = $00000008; // BSTR
  SPR_CHANNEL_INFO_PHONETO                        = $00000009; // BSTR
  SPR_CHANNEL_INFO_SUBPHONETO                     = $0000000A; // BSTR
  SPR_CHANNEL_INFO_RECORDTYPE                     = $0000000B; // LONG
  SPR_CHANNEL_INFO_FILENAME                       = $0000000C; // BSTR
  SPR_CHANNEL_INFO_RING                           = $0000000D; // WordBool
  SPR_CHANNEL_INFO_RINGFIRSTDATETIME              = $0000000E; // DateTime
  SPR_CHANNEL_INFO_RINGLENG                       = $0000000F; // LONG
  SPR_CHANNEL_INFO_RINGCOUNT                      = $00000010; // LONG
  SPR_CHANNEL_INFO_HANDSETTAKEN                   = $00000011; // WordBool
  SPR_CHANNEL_INFO_HANDSETTAKEDATETIME            = $00000012; // DateTime
  SPR_CHANNEL_INFO_HANDSETTAKELENG                = $00000013; // LONG

//  
const
  SPR_MAX_MSG_SIZE          = 32768;
  MAX_CHANNEL_NAME_CHARS    = 48;
  MAX_PHONE_NUMBER_CHARS    = 48;
  MAX_SUBPHONE_NUMBER_CHARS = 24;
  MAX_DEVICE_NAME_CHARS     = 64;
  MAX_SEND_AUDIO_DATA_SIZE  = SPR_MAX_MSG_SIZE - 12;
  MAX_COMMENT_CHARS         = 4096;

//  
type
  PMSGHeader = ^TMSGHeader;
  TMSGHeader = packed record
    dwMsgSize: DWORD;
    dwMsg: DWORD;
    MsgTime: TDateTime;
  end;
  MSGHEADER = TMSGHeader;

//    
type
  PMSGChannelName = ^TMSGChannelName;
  TMSGChannelName = packed record
    mh: TMSGHeader;
    cbChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
  end;
  MSGCHANNELNAME = TMSGChannelName;

  PMSGRing = ^TMSGRing;
  TMSGRing = packed record
    mh: TMSGHeader;
    cbChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
    dwRingCount: DWORD;
  end;
  MSGRING = TMSGRing;

  PMSGRecordStart = ^TMSGRecordStart;
  TMSGRecordStart = packed record
    mh: TMSGHeader;
    cbChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
    dwRecordType: DWORD;
    cbPhoneFrom: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneFrom: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbPhoneTo: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneTo: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbFileName: array[0..MAX_PATH - 1] of WideChar;
  end;
  MSGRECORDSTART = TMSGRecordStart;

  PMSGRecordStop = ^TMSGRecordStop;
  TMSGRecordStop = packed record
    mh: TMSGHeader;
    cbChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
    dwRecordType: DWORD;
    cbPhoneFrom: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneFrom: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbPhoneTo: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneTo: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbFileName: array[0..MAX_PATH - 1] of WideChar;
    dwLeng: DWORD;
    NormalStop: BOOL;
    bCompress: BOOL;
  end;
  MSGRECORDSTOP = TMSGRecordStop;

  PMSGPhoneNumber = ^TMSGPhoneNumber;
  TMSGPhoneNumber = packed record
    mh: TMSGHeader;
    cbChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
    cbPhoneNumber: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneNumber: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
  end;
  MSGPHONENUMBER = TMSGPhoneNumber;

  PMSGMissedPhone = ^TMSGMissedPhone;
  TMSGMissedPhone = packed record
    mh: TMSGHeader;
    cbChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
    cbPhoneFrom: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneFrom: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbPhoneTo: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneTo: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
  end;
  MSGMISSEDPHONE = TMSGMissedPhone;

  PMSGRecordType = ^TMSGRecordType;
  TMSGRecordType = packed record
    mh: TMSGHeader;
    cbChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
    dwRecordType: DWORD;
  end;
  MSGRECORDTYPE = TMSGRecordType;

  PMSGChangeChannelName = ^TMSGChangeChannelName;
  TMSGChangeChannelName = packed record
    mh: TMSGHeader;
    cbOldChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
    cbNewChannelName: array[0..MAX_CHANNEL_NAME_CHARS - 1] of WideChar;
  end;
  MSGCHANGECHANNELNAME = TMSGChangeChannelName;

  PMSGText = ^TMSGText;
  TMSGText = packed record
    mh: TMSGHeader;
    cbText: array[0..0] of WideChar;
  end;
  MSGTEXT = TMSGText;

  PMSGDestroyConnection = ^TMSGDestroyConnection;
  TMSGDestroyConnection = packed record
    mh: TMSGHeader;
    dwDestroyReason: DWORD;
  end;
  MSGDESTROYCONNECTION = TMSGDestroyConnection;

  PMSGDeviceName = ^TMSGDeviceName;
  TMSGDeviceName = packed record
    mh: TMSGHeader;
    cbDeviceName: array[0..MAX_DEVICE_NAME_CHARS - 1] of WideChar;
  end;
  MSGDEVICENAME = TMSGDeviceName;

  PMSGDeviceDisconnect = ^TMSGDeviceDisconnect;
  TMSGDeviceDisconnect = packed record
    mh: TMSGHeader;
    cbDeviceName: array[0..MAX_DEVICE_NAME_CHARS - 1] of WideChar;
    dsDisconnectReason: DWORD;
  end;
  MSGDEVICEDISCONNECT = TMSGDeviceDisconnect;

  PMSGCompressingFinished = ^TMSGCompressingFinished;
  TMSGCompressingFinished = packed record
    mh: TMSGHeader;
    cbFileName: array[0..MAX_PATH - 1] of WideChar;
  end;
  MSGCOMPRESSINGFINISHED = TMSGCompressingFinished;

//    
type
  PChannelMSGRing = ^TChannelMSGRing;
  TChannelMSGRing = packed record
    mh: TMSGHeader;
    dwRingCount: DWORD;
  end;
  CHANNELMSGRING = TChannelMSGRing;

  PChannelMSGRecordStart = ^TChannelMSGRecordStart;
  TChannelMSGRecordStart = packed record
    mh: TMSGHeader;
    dwRecordType: DWORD;
    cbPhoneFrom: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneFrom: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbPhoneTo: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneTo: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbFileName: array[0..MAX_PATH - 1] of WideChar;
  end;
  CHANNELMSGRECORDSTART = TChannelMSGRecordStart;

  PChannelMSGRecordStop = ^TChannelMSGRecordStop;
  TChannelMSGRecordStop = packed record
    mh: TMSGHeader;
    dwRecordType: DWORD;
    cbPhoneFrom: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneFrom: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbPhoneTo: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneTo: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbFileName: array[0..MAX_PATH - 1] of WideChar;
    dwLeng: DWORD;
    NormalStop: BOOL;
    bCompress: BOOL;
  end;
  CHANNELMSGRECORDSTOP = TChannelMSGRecordStop;

  PChannelMSGPhoneNumber = ^TChannelMSGPhoneNumber;
  TChannelMSGPhoneNumber = packed record
    mh: TMSGHeader;
    cbPhoneNumber: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneNumber: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
  end;
  CHANNELMSGPHONENUMBER = TChannelMSGPhoneNumber;

  PChannelMSGMissedPhone = ^TChannelMSGMissedPhone;
  TChannelMSGMissedPhone = packed record
    mh: TMSGHeader;
    cbPhoneFrom: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneFrom: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
    cbPhoneTo: array[0..MAX_PHONE_NUMBER_CHARS - 1] of WideChar;
    cbSubPhoneTo: array[0..MAX_SUBPHONE_NUMBER_CHARS - 1] of WideChar;
  end;
  CHANNELMSGMISSEDPHONE = TChannelMSGMissedPhone;

  PChannelMSGRecordType = ^TChannelMSGRecordType;
  TChannelMSGRecordType = packed record
    mh: TMSGHeader;
    dwRecordType: DWORD;
  end;
  CHANNELMSGRECORDTYPE = TChannelMSGRecordType;

  PChannelMSGData = ^TChannelMSGData;
  TChannelMSGData = packed record
    mh: TMSGHeader;
    dwDataSize: DWORD;
    cbData: array[0..0] of Byte;
  end;
  CHANNELMSGDATA = TChannelMSGData;

  PChannelMSGDTMFCode = ^TChannelMSGDTMFCode;
  TChannelMSGDTMFCode = packed record
    mh: TMSGHeader;
    dwDTMFCode: DWORD;
  end;
  CHANNELMSGDTMFCODE = TChannelMSGDTMFCode;

  PChannelMSGAudioBufState = ^TChannelMSGAudioBufState;
  TChannelMSGAudioBufState = packed record
    mh: TMSGHeader;
    dwMilliseconds: DWORD;
  end;
  CHANNELMSGAUDIOBUFSTATE = TChannelMSGAudioBufState;

implementation

end.
