unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComObj, ShlObj, ActiveX, StdCtrls, spsdksw_TLB, SpRecordLibTypesW,
  ExtCtrls, MMSystem, ComCtrls, ChannelClient_TLB, MyCOMEventsHookUnit,
  SoundPlayer;

type
  TMainForm = class(TForm)
    btnSelectServer: TButton;
    cbServer: TComboBox;
    LabelServer: TLabel;
    LabelChannel: TLabel;
    cbChannels: TComboBox;
    btnRefreshChannels: TButton;
    cbHardChannelNames: TCheckBox;
    cbUseCOMEvents: TCheckBox;
    MemoInfo: TMemo;
    btnDisconnect: TButton;
    btnClose: TButton;
    btnConnect: TButton;
    btnOpen: TButton;
    TimerMsg: TTimer;
    btnGetSpRecordVersion: TButton;
    btnGetLibVersion: TButton;
    btnStartRecord: TButton;
    btnStopRecord: TButton;
    btnDialNumber: TButton;
    cbDialNumber: TComboBox;
    cbDialNumberTone: TCheckBox;
    btnDialingCancel: TButton;
    btnHandsetTake: TButton;
    btnHandsetPut: TButton;
    btnSendAudioData: TButton;
    btnClearAudioData: TButton;
    cbFilesWAV: TComboBox;
    OpenDialog: TOpenDialog;
    LabelAudioBufStateInfo: TLabel;
    LabelAudioBufState: TLabel;
    pbFileData: TProgressBar;
    cbOutputMode: TCheckBox;
    cbExclusivMode: TCheckBox;
    cbDetectDTMF: TCheckBox;
    btnGetWriting: TButton;
    btnGetHandsetState: TButton;
    btnGetLineState: TButton;
    btnGetChannelHandsetState: TButton;
    btnGetAudioDataBufferState: TButton;
    btnGetDialing: TButton;
    btnGetFileName: TButton;
    btnGetComment: TButton;
    btnSetComment: TButton;
    btnGetAudioDataSubscribe: TButton;
    cbSoundSubscribe: TCheckBox;
    EditComment: TEdit;
    btnGetDTMFDetect: TButton;
    btnGetOutputMode: TButton;
    btnGetAudioVolume: TButton;
    btnGetChannelSupport: TButton;
    btnGetDeviceName: TButton;
    btnGetInputWF: TButton;
    btnGetOutputWF: TButton;
    LabelVolume: TLabel;
    tbVolume: TTrackBar;
    btnClearLog: TButton;
    btnGetReadyToCall: TButton;
    cbGetInfo: TComboBox;
    LabelGetInfo: TLabel;
    procedure btnSelectServerClick(Sender: TObject);
    procedure btnRefreshChannelsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnGetLibVersionClick(Sender: TObject);
    procedure btnGetSpRecordVersionClick(Sender: TObject);
    procedure btnStartRecordClick(Sender: TObject);
    procedure btnStopRecordClick(Sender: TObject);
    procedure btnDialNumberClick(Sender: TObject);
    procedure btnDialingCancelClick(Sender: TObject);
    procedure btnHandsetTakeClick(Sender: TObject);
    procedure btnHandsetPutClick(Sender: TObject);
    procedure btnSendAudioDataClick(Sender: TObject);
    procedure btnClearAudioDataClick(Sender: TObject);
    procedure cbFilesWAVDblClick(Sender: TObject);
    procedure TimerMsgTimer(Sender: TObject);
    procedure cbOutputModeClick(Sender: TObject);
    procedure cbDetectDTMFClick(Sender: TObject);
    procedure btnGetWritingClick(Sender: TObject);
    procedure btnGetHandsetStateClick(Sender: TObject);
    procedure btnGetLineStateClick(Sender: TObject);
    procedure btnGetChannelHandsetStateClick(Sender: TObject);
    procedure btnGetAudioDataBufferStateClick(Sender: TObject);
    procedure btnGetDialingClick(Sender: TObject);
    procedure btnGetFileNameClick(Sender: TObject);
    procedure btnGetCommentClick(Sender: TObject);
    procedure btnSetCommentClick(Sender: TObject);
    procedure btnGetAudioDataSubscribeClick(Sender: TObject);
    procedure cbSoundSubscribeClick(Sender: TObject);
    procedure btnGetDTMFDetectClick(Sender: TObject);
    procedure btnGetOutputModeClick(Sender: TObject);
    procedure btnGetAudioVolumeClick(Sender: TObject);
    procedure btnGetChannelSupportClick(Sender: TObject);
    procedure btnGetDeviceNameClick(Sender: TObject);
    procedure tbVolumeChange(Sender: TObject);
    procedure btnGetInputWFClick(Sender: TObject);
    procedure btnGetOutputWFClick(Sender: TObject);
    procedure btnClearLogClick(Sender: TObject);
    procedure cbUseCOMEventsClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnGetReadyToCallClick(Sender: TObject);
    procedure cbGetInfoChange(Sender: TObject);
  private
    FSoundPlayer: TSoundPlayer;
    FChannel: ISpRecordChannelClientWDisp;
    FEventsHook: IMyCOMEventsHook;
    FCP: IConnectionPoint;
    FCookie: Longint;
    FSignalBuf: array of Byte;
    FSignalIndex: Integer;
    procedure ShowSDKError(Error: Integer);
    procedure ShowSDKMsg(const Msg: OleVariant);
    procedure RefreshCOMEvents;
    procedure RefreshEnables;
    procedure SendNextAudioData;
    procedure OnMessage(const Msg: OleVariant);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

const
  ChannelFlag: array[Boolean] of Integer = (SPR_CHANNEL_USERNAME, SPR_CHANNEL_HARDNAME);
  DialFlag: array[Boolean] of Integer = (DIAL_PULSE, DIAL_TONE);

function LoadWAVData(const FileName: String; lpBuf: Pointer;
  var DataSize: Integer; SamplesPerSec: DWORD): Boolean;
  var
    hFile: Integer;
       rc: record ckid: FOURCC; cksize: DWORD; end;
     ckid: FOURCC;
      bOk: Boolean;
    pcmwf: TPCMWaveFormat;
       ds: Integer;
begin
  Result := False;
  hFile := FileOpen(FileName, fmOpenRead or fmShareDenyWrite);
  if hFile <> -1 then
  try
    bOk := (FileRead(hFile, rc, SizeOf(rc)) = SizeOf(rc)) and (rc.ckid = FOURCC_RIFF);

    bOk := bOk and (FileRead(hFile, ckid, SizeOf(ckid)) = SizeOf(ckid)) and
      (ckid = $45564157 {'WAVE'});

    bOk := bOk and (FileRead(hFile, rc, SizeOf(rc)) = SizeOf(rc)) and
      (rc.ckid = $20746D66 {'fmt '}) and (rc.cksize >= SizeOf(TPCMWaveFormat));

    bOk := bOk and (FileRead(hFile, pcmwf, SizeOf(pcmwf)) = SizeOf(pcmwf)) and
      (pcmwf.wf.wFormatTag = WAVE_FORMAT_PCM) and (pcmwf.wf.nChannels = 1) and
      (pcmwf.wBitsPerSample = 8) and (pcmwf.wf.nSamplesPerSec = SamplesPerSec);

    bOk := bOk and (FileSeek(hFile, rc.cksize - SizeOf(pcmwf), 1) = rc.cksize + 20);

    bOk := bOk and (FileRead(hFile, rc, SizeOf(rc)) = SizeOf(rc));
    while bOk and (rc.ckid <> $61746164 {'data'}) do
    begin
      bOk := FileSeek(hFile, rc.cksize, 1) >= 0;
      bOk := bOk and (FileRead(hFile, rc, SizeOf(rc)) = SizeOf(rc));
    end;

    if bOk and (rc.ckid = $61746164 {'data'}) then
    begin
      ds := Integer(GetFileSize(THandle(hFile), nil)) - FileSeek(hFile, 0, 1);
      if Integer(rc.cksize) < ds then ds := rc.cksize;

      if Assigned(lpBuf) then
      begin
        if ds > DataSize then ds := DataSize;
        DataSize := FileRead(hFile, lpBuf^, ds);
      end else
        DataSize := ds;
      Result := DataSize = ds;
    end;
  finally
    FileClose(hFile);
  end;
end;

procedure TMainForm.SendNextAudioData;
  var eResult: Integer;
       Signal: OleVariant;
        lpBuf: Pointer;
         Size: Integer;
         Flag: Integer;
begin
  Size := Length(FSignalBuf) - FSignalIndex;
  if Size > 0 then
  begin
    if Size > 11025 then Size := 11025;
    if Size > MAX_SEND_AUDIO_DATA_SIZE then Size := MAX_SEND_AUDIO_DATA_SIZE;
    Signal := VarArrayCreate([0, Size - 1], varByte);
    lpBuf := VarArrayLock(Signal);
    try
      Move(FSignalBuf[FSignalIndex], lpBuf^, Size);
    finally
      VarArrayUnlock(Signal);
    end;
    Flag := 0;
    if FSignalIndex = 0 then Flag := Flag or SPR_AUDIODATA_BEGIN;
    if Size + FSignalIndex = Length(FSignalBuf) then Flag := Flag or SPR_AUDIODATA_END;
    eResult := FChannel.SendAudioData(Signal, Flag);
    if eResult = SPR_S_OK then
    begin
      Inc(FSignalIndex, Size);
      pbFileData.Position := FSignalIndex;
    end else
    begin
      SetLength(FSignalBuf, 0);
      FSignalIndex := 0;
      MemoInfo.Lines.Add('');
      MemoInfo.Lines.Add('SendAudioData error. Error 0x' + IntToHex(eResult, 8));
      MemoInfo.Lines.Add('');
    end;
  end;
end;

procedure TMainForm.ShowSDKError(Error: Integer);
  var eStr: String;
begin
  if Error and $80000000 = 0 then
  begin
    eStr := 'Operation complited.';
    if Error <> SPR_S_OK then eStr := eStr + ' Result: 0x' + IntToHex(Error, 8);
  end else
    eStr := 'Operation failed. Error: 0x' + IntToHex(Error, 8);
  MemoInfo.Lines.Add('');
  MemoInfo.Lines.Add(eStr);
  MemoInfo.Lines.Add('');
end;

procedure TMainForm.ShowSDKMsg(const Msg: OleVariant);
  const
    DTMFChars: array[0..15] of Char = ('0', '1', '2', '3', '4', '5', '6',
      '7', '8', '9', '*', '#', 'A', 'B', 'C', 'D');
  var lpMsg: PMSGHeader;
        Str: String;
begin
  lpMsg := VarArrayLock(Msg);
  try
    Str := DateTimeToStr(lpMsg.MsgTime) + ' [0x' + IntToHex(lpMsg.dwMsg, 8) + ']: ';
    case lpMsg.dwMsg of
      SPR_MSG_C_RECORD_START:
        with PChannelMSGRecordStart(lpMsg)^ do
          Str := 'Start: Type: ' + IntToStr(dwRecordType) + ', PhoneFrom: ' +
            cbPhoneFrom + ', PhoneTo: ' + cbPhoneFrom + ', FileName: ' + cbFileName;
      SPR_MSG_C_RING:
        with PChannelMSGRing(lpMsg)^ do
          Str := 'Ring:' + IntToStr(dwRingCount);
      SPR_MSG_C_ANI_DETECT:
        with PChannelMSGPhoneNumber(lpMsg)^ do
          Str := 'ANI: ' + cbPhoneNumber;
      SPR_MSG_C_RECORD_TYPE:
        with PChannelMSGRecordType(lpMsg)^ do
          Str := 'Record Type: ' + IntToStr(dwRecordType);
      SPR_MSG_C_DIALLED_PHONE:
        with PChannelMSGPhoneNumber(lpMsg)^ do
          Str := 'Out Phone: ' + cbPhoneNumber;
      SPR_MSG_C_MISSED_PHONE:
        with PChannelMSGMissedPhone(lpMsg)^ do
          Str := 'Missed PhoneFrom: ' + cbPhoneFrom + ', PhoneTo: ' + cbPhoneTo;
      SPR_MSG_C_RECORD_STOP:
        with PChannelMSGRecordStop(lpMsg)^ do
          Str := 'Stop: Type: ' + IntToStr(dwRecordType) + ', PhoneFrom: ' +
            cbPhoneFrom + ', PhoneTo: ' + cbPhoneTo + ', FileName: ' + cbFileName +
            ', Leng: ' + IntToStr(dwLeng) + ', NormalStop: ' + BoolToStr(NormalStop, True) +
            ', bCompress: ' + BoolToStr(bCompress, True);
      SPR_MSG_CHANGE_CHANNEL_NAME:
        with PMSGChangeChannelName(lpMsg)^ do
          Str := 'New Channel Name: ' + cbNewChannelName;
      SPR_MSG_C_DIALINGISCOMPLETED:
        Str := 'Dialing is completed';
      SPR_MSG_C_DTMF:
        with PChannelMSGDTMFCode(lpMsg)^ do
          Str := 'DTMF: ' + DTMFChars[dwDTMFCode];
      SPR_MSG_C_LINEBUSY: Str := 'Line is Busy';
      SPR_MSG_C_AUDIOBUFSTATE:
        with PChannelMSGAudioBufState(lpMsg)^ do
      begin
        if dwMilliseconds < 500 then SendNextAudioData;
        Str := '';
        LabelAudioBufState.Caption := IntToStr(dwMilliseconds);
      end;
      SPR_MSG_C_LINEOFF: Str := 'Line Off';
      SPR_MSG_C_LINEON: Str := 'Line On';
      SPR_MSG_C_HANDSETOFF: Str := 'Handset Off';
      SPR_MSG_C_HANDSETON: Str := 'Handset On';
      SPR_MSG_C_TARGETTAKENHANDSET: Str := 'The target has taken a handset';
      SPR_MSG_C_AUDIODATA:
        with PChannelMSGData(lpMsg)^ do
      begin
        Str := '';
        FSoundPlayer.AddBufToPlay(@cbData, dwDataSize);
      end;
      SPR_MSG_DESTROY_CONNECTION:
        with PMSGDestroyConnection(lpMsg)^ do
          Str := 'DestroyReason: ' + IntToStr(dwDestroyReason);
      SPR_MSG_C_CONVERSATION_BEGIN: Str := 'Conversation begin';
      SPR_MSG_C_CONVERSATION_END: Str := 'Conversation end';
      SPR_MSG_C_PHONEHANDSETON: Str := 'Handset Phone On';
      SPR_MSG_C_CALLSENDINGCONTROL: Str := 'Control of sending of call';
      SPR_MSG_POWERSUSPEND: Str := 'Power Suspend';
      SPR_MSG_TEXT: Str := PChar(@PMSGText(lpMsg).cbText);
      SPR_MSG_C_CARRIER: Str := 'Carrier';
      SPR_MSG_C_FAX_DETECTED: Str := 'Fax detected';
    end;
  finally
    VarArrayUnlock(Msg);
  end;
  if Str <> '' then
    MemoInfo.Lines.Add(Str);
end;

procedure TMainForm.OnMessage(const Msg: OleVariant);
begin
  ShowSDKMsg(Msg);
end;

procedure TMainForm.RefreshCOMEvents;
  var CPC: IConnectionPointContainer;
    cHook: TMyCOMEventsHook;
begin
  if FChannel <> nil then
  if cbUseCOMEvents.Checked then
  begin
    cHook := TMyCOMEventsHook.Create;
    cHook.OnHook := OnMessage;
    FEventsHook := cHook as IMyCOMEventsHook;

    CPC := FChannel as IConnectionPointContainer;
    OleCheck(CPC.FindConnectionPoint(DIID_ISpRecordChannelClientWEvents, FCP));
    OleCheck(FCP.Advise(FEventsHook, FCookie));

    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('Events seted.');
    MemoInfo.Lines.Add('');
  end else
  begin
    if Assigned(FCP) then
      OleCheck(FCP.Unadvise(FCookie));

    FCP := nil;
    FEventsHook := nil;

    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('Events unseted.');
    MemoInfo.Lines.Add('');
  end;
  TimerMsg.Enabled := (FChannel <> nil) and (FEventsHook = nil);
end;

procedure TMainForm.RefreshEnables;
begin

end;

procedure TMainForm.TimerMsgTimer(Sender: TObject);
  var Msg: OleVariant;
begin
 if FChannel <> nil then
 try
   while FChannel.PeekMessage(Msg) = SPR_S_OK do
     ShowSDKMsg(Msg);
 except
   btnClose.Click;
   raise;
 end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FSoundPlayer := TSoundPlayer.Create;
  MemoInfo.Clear;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FSoundPlayer.Free;
end;

procedure TMainForm.btnClearLogClick(Sender: TObject);
begin
  MemoInfo.Clear;
end;

procedure TMainForm.btnSelectServerClick(Sender: TObject);
  var
    WindowList: Pointer;
    BrowseInfo: TBrowseInfo;
    Buffer: PChar;
    RootItemIDList, ItemIDList: PItemIDList;
    ShellMalloc: IMalloc;
begin
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    try
      if SHGetSpecialFolderLocation(Application.Handle, CSIDL_NETWORK, RootItemIDList) <> NOERROR then
        RootItemIDList := nil;
      with BrowseInfo do
      begin
        hwndOwner := Application.Handle;
        pidlRoot := RootItemIDList;
        pszDisplayName := Buffer;
        lpszTitle := 'Select computer name:';
        ulFlags := BIF_BROWSEFORCOMPUTER;
      end;
      WindowList := DisableTaskWindows(0);
      try
        ItemIDList := ShBrowseForFolder(BrowseInfo);
      finally
        EnableTaskWindows(WindowList);
      end;
      if ItemIDList <> nil then
      begin
        ShellMalloc.Free(ItemIDList);
        cbServer.Text := Buffer;
      end;
    finally
      ShellMalloc.Free(Buffer);
    end;
  end;
end;

procedure TMainForm.cbFilesWAVDblClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    cbFilesWAV.Text := OpenDialog.FileName;
end;

procedure TMainForm.btnRefreshChannelsClick(Sender: TObject);
  var Main: ISpRecordClientWDisp;
    Server: String;
       Obj: IUnknown;
    lNames: TStrings;
     Names: WideString;
   eResult: Integer;
begin
  Server := cbServer.Text;
  if Server = '' then Obj := CreateComObject(CLASS_SpRecordClientW)
    else Obj := CreateRemoteComObject(Server, CLASS_SpRecordClientW);
  Main := ISpRecordClientWDisp(Obj as IDispatch);

  eResult := Main.Connect(0, '', '');
  if eResult = SPR_S_OK then
    eResult := Main.GetChannelNames(ChannelFlag[cbHardChannelNames.Checked], Names);
  if eResult = SPR_S_OK then
  begin
    lNames := TStringList.Create;
    try
      lNames.LineBreak := '|';
      lNames.Text := Names;
      cbChannels.Items.Assign(lNames);
    finally
      lNames.Free;
    end;
    if cbChannels.Items.Count > 0 then cbChannels.ItemIndex := 0;
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.cbUseCOMEventsClick(Sender: TObject);
begin
  RefreshCOMEvents;
end;

procedure TMainForm.btnOpenClick(Sender: TObject);
  var Server: String;
         Obj: IUnknown;
begin
  Server := cbServer.Text;
  if Server = '' then Obj := CreateComObject(CLASS_SpRecordChannelClientW)
    else Obj := CreateRemoteComObject(Server, CLASS_SpRecordChannelClientW);
  FChannel := ISpRecordChannelClientWDisp(Obj as IDispatch);
  RefreshCOMEvents;
  RefreshEnables;
end;

procedure TMainForm.btnConnectClick(Sender: TObject);
  var eResult: Integer;
         Flag: Integer;
begin
  Flag := ChannelFlag[cbHardChannelNames.Checked];
  if cbExclusivMode.Checked then Flag := Flag or SPR_CHANNEL_EXCLUSIVE;
  eResult := FChannel.Connect(cbChannels.Text, Flag, '', '');
  ShowSDKError(eResult);
  cbOutputModeClick(Sender);
  cbDetectDTMFClick(Sender);
  cbSoundSubscribeClick(Sender);
  RefreshEnables;
end;

procedure TMainForm.btnDisconnectClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.Disconnect;
  ShowSDKError(eResult);
  RefreshEnables;
end;

procedure TMainForm.btnCloseClick(Sender: TObject);
begin
//  TimerMsg.Enabled := False;
  try
    if Assigned(FCP) then OleCheck(FCP.Unadvise(FCookie));
  finally
    FCP := nil;
//    FEventsHook := nil;
    FChannel := nil;
    RefreshEnables;
  end;
end;

procedure TMainForm.btnGetLibVersionClick(Sender: TObject);
  var Version: Integer;
begin
  Version := FChannel.GetLibVersion;
  MemoInfo.Lines.Add('');
  MemoInfo.Lines.Add('SDK DLL Version: ' + IntToStr(Version shr 16) + '.' + IntToStr(Version and $FFFF));
  MemoInfo.Lines.Add('');
end;

procedure TMainForm.btnGetSpRecordVersionClick(Sender: TObject);
  var Version: Integer;
      eResult: Integer;
begin
  eResult := FChannel.GetSpRecordVersion(Version);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('SpRecord Version: ' + IntToStr(Version shr 16) + '.' + IntToStr(Version and $FFFF));
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnStartRecordClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.StartRecord;
  ShowSDKError(eResult);
end;

procedure TMainForm.btnStopRecordClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.StopRecord;
  ShowSDKError(eResult);
end;

procedure TMainForm.btnDialNumberClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.DialNumber(cbDialNumber.Text, DialFlag[cbDialNumberTone.Checked]);
  ShowSDKError(eResult);
end;

procedure TMainForm.btnDialingCancelClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.DialingCancel;
  ShowSDKError(eResult);
end;

procedure TMainForm.btnHandsetTakeClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.HandsetTake;
  ShowSDKError(eResult);
end;

procedure TMainForm.btnHandsetPutClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.HandsetPut;
  ShowSDKError(eResult);
end;

procedure TMainForm.btnSendAudioDataClick(Sender: TObject);
  var DataSize: Integer;
begin
  DataSize := 0;
  if LoadWAVData(cbFilesWAV.Text, nil, DataSize, 11025) then
  begin
    SetLength(FSignalBuf, DataSize);
    FSignalIndex := 0;
    if LoadWAVData(cbFilesWAV.Text, @FSignalBuf[0], DataSize, 11025) then
    begin
      pbFileData.Position := 0;
      pbFileData.Max := DataSize;
      SendNextAudioData;
    end else
    begin
      SetLength(FSignalBuf, 0);
      MemoInfo.Lines.Add('');
      MemoInfo.Lines.Add('File loading error.');
      MemoInfo.Lines.Add('');
    end;
  end else
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('File loading error.');
    MemoInfo.Lines.Add('');
  end;
end;

procedure TMainForm.btnClearAudioDataClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.ClearAudioData;
  SetLength(FSignalBuf, 0);
  FSignalIndex := 0;
  pbFileData.Position := 0;
  pbFileData.Max := 100;
  ShowSDKError(eResult);
end;

procedure TMainForm.cbOutputModeClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.SetOutputMode(cbOutputMode.Checked);
  if eResult = SPR_S_OK then
    MemoInfo.Lines.Add('OutputMode is ' + BoolToStr(cbOutputMode.Checked, True))
  else
    ShowSDKError(eResult);
end;

procedure TMainForm.cbDetectDTMFClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.SetDTMFDetect(cbDetectDTMF.Checked);
  if eResult = SPR_S_OK then
    MemoInfo.Lines.Add('DTMFDetect is ' + BoolToStr(cbDetectDTMF.Checked, True))
  else
    ShowSDKError(eResult);
end;

procedure TMainForm.cbSoundSubscribeClick(Sender: TObject);
  var eResult: Integer;
          wfx: OleVariant;
        lpWFX: PWaveFormatEx;
begin
  eResult := FChannel.SetAudioDataSubscribe(cbSoundSubscribe.Checked);
  if (eResult = SPR_S_OK) and cbSoundSubscribe.Checked then
  begin
    eResult := FChannel.GetInputWF(wfx);
    if eResult = SPR_S_OK then
    begin
      lpWFX := VarArrayLock(wfx);
      try
        FSoundPlayer.SetWaveFormat(lpWFX.nChannels, lpWFX.wBitsPerSample, lpWFX.nSamplesPerSec);
      finally
        VarArrayUnlock(wfx);
      end;
      FSoundPlayer.Open;
      MemoInfo.Lines.Add('Sound Subscribe On.');
    end;
  end else
  begin
    FSoundPlayer.Close;
    if eResult = SPR_S_OK then
      MemoInfo.Lines.Add('Sound Subscribe Off.');
  end;
  if eResult <> SPR_S_OK then
    ShowSDKError(eResult);
end;

procedure TMainForm.tbVolumeChange(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.SetAudioVolume(tbVolume.Position);
  if eResult <> SPR_S_OK then
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetWritingClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetWriting(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('Writing is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetHandsetStateClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetHandsetState(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('HandsetState is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetLineStateClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetLineState(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('LineState is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;


procedure TMainForm.btnGetChannelHandsetStateClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetChannelHandsetState(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('ChannelHandsetState is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetDialingClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetDialing(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('Dialing is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetFileNameClick(Sender: TObject);
  var eResult: Integer;
     FileName: WideString;
begin
  eResult := FChannel.GetFileName(FileName);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('Filename is ' + FileName + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetAudioDataBufferStateClick(Sender: TObject);
  var eResult: Integer;
        Value: Integer;
begin
  eResult := FChannel.GetAudioDataBufferState(Value);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('AudioDataBufferState is ' + IntToStr(Value) + 'ms.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetCommentClick(Sender: TObject);
  var eResult: Integer;
        Value: WideString;
begin
  eResult := FChannel.GetComment(Value);
  if eResult = SPR_S_OK then
    EditComment.Text := Value;
  ShowSDKError(eResult);
end;

procedure TMainForm.btnSetCommentClick(Sender: TObject);
  var eResult: Integer;
begin
  eResult := FChannel.SetComment(EditComment.Text);
  ShowSDKError(eResult);
end;

procedure TMainForm.btnGetDTMFDetectClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetDTMFDetect(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('DTMFDetect is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetAudioDataSubscribeClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetAudioDataSubscribe(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('AudioDataSubscribe is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetOutputModeClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetOutputMode(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('OutputMode is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetAudioVolumeClick(Sender: TObject);
  var eResult: Integer;
       Volume: Integer;
begin
  eResult := FChannel.GetAudioVolume(Volume);
  if eResult = SPR_S_OK then
  begin
    tbVolume.Position := Volume;
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('AudioVolume is ' + IntToStr(Volume) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetChannelSupportClick(Sender: TObject);
  var Support: Integer;
      eResult: Integer;
      Channel: String;
          Str: String;
begin
  Channel := cbChannels.Text;
  eResult := FChannel.GetChannelSupport(Support);
  if eResult = SPR_S_OK then
  begin
    Str := '';
    if Support and SPR_DEVICE_SUPPORT_LINESTATE <> 0 then
    begin
      if Str <> '' then Str := Str + ', ';
      Str := Str + 'Line State';
    end;
    if Support and SPR_DEVICE_SUPPORT_VOICEMAIL <> 0 then
    begin
      if Str <> '' then Str := Str + ', ';
      Str := Str + 'VoiceMail';
    end;
    if Support and SPR_DEVICE_SUPPORT_ISDNBRI <> 0 then
    begin
      if Str <> '' then Str := Str + ', ';
      Str := Str + 'ISDN BRI';
    end;
    if Support and SPR_DEVICE_SUPPORT_ISDN <> 0 then
    begin
      if Str <> '' then Str := Str + ', ';
      Str := Str + 'ISDN';
    end;
    if Support and SPR_DEVICE_SUPPORT_DIGITAL <> 0 then
    begin
      if Str <> '' then Str := Str + ', ';
      Str := Str + 'DIGITAL';
    end;
    if Str = '' then Str := 'none';
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('Channel ' + Channel + ' support ' + Str);
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetDeviceNameClick(Sender: TObject);
  var  eResult: Integer;
    DevaceName: WideString;
begin
  eResult := FChannel.GetDeviceName(DevaceName);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('DeviceName is ' + DevaceName + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetInputWFClick(Sender: TObject);
  var  eResult: Integer;
           wfx: OleVariant;
         lpWFX: PWaveFormatEx;
           Str: String;
begin
  eResult := FChannel.GetInputWF(wfx);
  if eResult = SPR_S_OK then
  begin
    lpWFX := VarArrayLock(wfx);
    try
      Str := 'wFormatTag: ' + IntToStr(lpWFX.wFormatTag) +
        ', nChannels: ' + IntToStr(lpWFX.nChannels) +
        ', nSamplesPerSec: ' + IntToStr(lpWFX.nSamplesPerSec) +
        ', nAvgBytesPerSec: ' + IntToStr(lpWFX.nAvgBytesPerSec) +
        ', nBlockAlign: ' + IntToStr(lpWFX.nBlockAlign) +
        ', wBitsPerSample: ' + IntToStr(lpWFX.wBitsPerSample) +
        ', cbSize: ' + IntToStr(lpWFX.cbSize);
    finally
      VarArrayUnlock(wfx);
    end;
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('Input wave format is ' + Str + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetOutputWFClick(Sender: TObject);
  var  eResult: Integer;
           wfx: OleVariant;
         lpWFX: PWaveFormatEx;
           Str: String;
begin
  eResult := FChannel.GetOutputWF(wfx);
  if eResult = SPR_S_OK then
  begin
    lpWFX := VarArrayLock(wfx);
    try
      Str := 'wFormatTag: ' + IntToStr(lpWFX.wFormatTag) +
        ', nChannels: ' + IntToStr(lpWFX.nChannels) +
        ', nSamplesPerSec: ' + IntToStr(lpWFX.nSamplesPerSec) +
        ', nAvgBytesPerSec: ' + IntToStr(lpWFX.nAvgBytesPerSec) +
        ', nBlockAlign: ' + IntToStr(lpWFX.nBlockAlign) +
        ', wBitsPerSample: ' + IntToStr(lpWFX.wBitsPerSample) +
        ', cbSize: ' + IntToStr(lpWFX.cbSize);
    finally
      VarArrayUnlock(wfx);
    end;
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('Output wave format is ' + Str + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.btnGetReadyToCallClick(Sender: TObject);
  var eResult: Integer;
        bFlag: WordBool;
begin
  eResult := FChannel.GetReadyToCall(bFlag);
  if eResult = SPR_S_OK then
  begin
    MemoInfo.Lines.Add('');
    MemoInfo.Lines.Add('ReadyToCall is ' + BoolToStr(bFlag, True) + '.');
    MemoInfo.Lines.Add('');
  end else
    ShowSDKError(eResult);
end;

procedure TMainForm.cbGetInfoChange(Sender: TObject);
  var eResult: Integer;
        Value: OleVariant;
begin
  if cbGetInfo.ItemIndex > 0 then
  begin
    eResult := FChannel.GetInfo(cbGetInfo.ItemIndex, Value);
    if eResult = SPR_S_OK then
      MemoInfo.Lines.Add('GetInfo [' + cbGetInfo.Text + ']: ' + String(Value))
    else
      ShowSDKError(eResult);
  end;
end;

end.
