
#ifndef SpRecordLibTypesWH
#define SpRecordLibTypesWH

#include <windef.h>

//     

#define  SPR_CHANNEL_HARDNAME                 0x00000001
#define  SPR_CHANNEL_USERNAME                 0x00000002
#define  SPR_CHANNEL_EXCLUSIVE                0x00000004

//   

#define  SPR_E_BASE                           0x80040200L
#define  SPR_S_BASE                           0x00040200L

#define  SPR_S_OK                             0x00000000L
#define  SPR_S_FALSE                          0x00000001L

#define  SPR_S_CONNECTIONNOTFOUND             SPR_S_BASE + 0x0001L
#define  SPR_S_WAITDISCONNECTTIMEOUT          SPR_S_BASE + 0x0002L
#define  SPR_S_WAIT_TIMEOUT                   SPR_S_BASE + 0x0003L

#define  SPR_E_ACCESS_DENIED                  SPR_E_BASE + 0x1001L
#define  SPR_E_CONNECT_LIMIT                  SPR_E_BASE + 0x1002L
#define  SPR_E_NOTFOUNDCHANNELNAME            SPR_E_BASE + 0x1003L
#define  SPR_E_SOCKETOPEN                     SPR_E_BASE + 0x1004L
#define  SPR_E_WAIT_FAILED                    SPR_E_BASE + 0x1005L
#define  SPR_E_CLIENTSOCKETOPEN               SPR_E_BASE + 0x1006L
#define  SPR_E_NOCONNECT                      SPR_E_BASE + 0x1007L
#define  SPR_E_INSUFFICIENT_BUFFER            SPR_E_BASE + 0x1008L
#define  SPR_E_NOMEMORY                       SPR_E_BASE + 0x1009L

#define  SPR_E_UNKNOWNCMD                     SPR_E_BASE + 0x100AL
#define  SPR_E_NOTSUPPORT                     SPR_E_BASE + 0x100BL
#define  SPR_E_INVALIDNUMBER                  SPR_E_BASE + 0x100CL
#define  SPR_E_ALREADYUSE                     SPR_E_BASE + 0x100DL
#define  SPR_E_INEXCLUSIVEMODE                SPR_E_BASE + 0x100EL
#define  SPR_E_NUMBERISDIALING                SPR_E_BASE + 0x100FL
#define  SPR_E_CMDWAITERROR                   SPR_E_BASE + 0x1010L
#define  SPR_E_LIBVERSION                     SPR_E_BASE + 0x1011L
#define  SPR_E_OUTPUTMODEALREADYUSE           SPR_E_BASE + 0x1012L
#define  SPR_E_NOTINOUTPUTMODE                SPR_E_BASE + 0x1013L
#define  SPR_E_HANDSETTAKENOTHERUSER          SPR_E_BASE + 0x1014L
#define  SPR_E_HANDSETNOTTAKE                 SPR_E_BASE + 0x1015L
#define  SPR_E_NOTWRITING                     SPR_E_BASE + 0x1016L
#define  SPR_E_USEEVENTOBJECT                 SPR_E_BASE + 0x1017L
#define  SPR_E_DEVICENOTUSE                   SPR_E_BASE + 0x1018L
#define  SPR_E_CHANNELNOTUSE                  SPR_E_BASE + 0x1019L
#define  SPR_E_NOTFOUNDDEVICENAME             SPR_E_BASE + 0x101AL
#define  SPR_E_NORECORDDETECT                 SPR_E_BASE + 0x101BL
#define  SPR_E_ALREADYWRITEAUTO               SPR_E_BASE + 0x101CL
#define  SPR_E_ALREADYWRITEUSER               SPR_E_BASE + 0x101DL
#define  SPR_E_NOTYOURWRITING                 SPR_E_BASE + 0x101EL
#define  SPR_E_VOICEMAILWORKING               SPR_E_BASE + 0x101FL
#define  SPR_E_SENDCMDPARAM                   SPR_E_BASE + 0x1020L
#define  SPR_E_SPRECORDPRGNOTFOUND            SPR_E_BASE + 0x1021L
#define  SPR_E_USERNAMEORPASSWORD             SPR_E_BASE + 0x1022L
#define  SPR_E_NOCONVERSATION                 SPR_E_BASE + 0x1023L
#define  SPR_E_NORING                         SPR_E_BASE + 0x1024L

#define  SPR_E_UNKNOWNERROR                   SPR_E_BASE + 0x1100L
#define  SPR_E_INVALIDARG                     0x80070057L

//     

#define  SPR_DEVICE_SUPPORT_LINESTATE         0x00000001
#define  SPR_DEVICE_SUPPORT_VOICEMAIL         0x00000002
#define  SPR_DEVICE_SUPPORT_ISDNBRI           0x00000004
#define  SPR_DEVICE_SUPPORT_ISDN              0x00000008
#define  SPR_DEVICE_SUPPORT_DIGITAL           0x00000010

//      

#define  SPR_AUDIODATA_BEGIN                  0x00000001
#define  SPR_AUDIODATA_END                    0x00000002

//   

#define  DIAL_PULSE                           0x00000001
#define  DIAL_TONE                            0x00000002

//    

#define  SPR_MSG_RECORD_START                 0x00000001
#define  SPR_MSG_RING                         0x00000002
#define  SPR_MSG_ANI_DETECT                   0x00000003
#define  SPR_MSG_RECORD_TYPE                  0x00000004
#define  SPR_MSG_DIALLED_PHONE                0x00000005
#define  SPR_MSG_MISSED_PHONE                 0x00000006
#define  SPR_MSG_RECORD_STOP                  0x00000007
#define  SPR_MSG_DEVICE_CONNECTED             0x00000008
#define  SPR_MSG_DEVICE_DISCONNECTED          0x00000009
#define  SPR_MSG_CONVERSATION_BEGIN           0x0000000A
#define  SPR_MSG_CONVERSATION_END             0x0000000B
#define  SPR_MSG_COMPRESSING_FINISHED         0x0000000C
#define  SPR_MSG_FAX_DETECTED                 0x0000000D

//    

#define  SPR_MSG_C_RECORD_START               0x00008001
#define  SPR_MSG_C_RING                       0x00008002
#define  SPR_MSG_C_ANI_DETECT                 0x00008003
#define  SPR_MSG_C_RECORD_TYPE                0x00008004
#define  SPR_MSG_C_DIALLED_PHONE              0x00008005
#define  SPR_MSG_C_MISSED_PHONE               0x00008006
#define  SPR_MSG_C_RECORD_STOP                0x00008007

#define  SPR_MSG_C_AUDIODATA                  0x00008008
#define  SPR_MSG_C_DIALINGISCOMPLETED         0x00008009
#define  SPR_MSG_C_DTMF                       0x0000800A
#define  SPR_MSG_C_LINEBUSY                   0x0000800B
#define  SPR_MSG_C_AUDIOBUFSTATE              0x0000800C
#define  SPR_MSG_C_LINEOFF                    0x0000800D
#define  SPR_MSG_C_LINEON                     0x0000800E
#define  SPR_MSG_C_HANDSETOFF                 0x0000800F
#define  SPR_MSG_C_HANDSETON                  0x00008010
#define  SPR_MSG_C_TARGETTAKENHANDSET         0x00008011
#define  SPR_MSG_C_CONVERSATION_BEGIN         0x00008012
#define  SPR_MSG_C_CONVERSATION_END           0x00008013
#define  SPR_MSG_C_PHONEHANDSETON             0x00008014
#define  SPR_MSG_C_CALLSENDINGCONTROL         0x00008015
#define  SPR_MSG_C_FILECREATEERROR            0x00008016
#define  SPR_MSG_C_CARRIER                    0x00008017
#define  SPR_MSG_C_FAX_DETECTED               0x00008018

//  

#define  SPR_MSG_CHANGE_CHANNEL_NAME          0x00010001
#define  SPR_MSG_TEXT                         0x00010002
#define  SPR_MSG_POWERSUSPEND                 0x00010003
#define  SPR_MSG_DESTROY_CONNECTION           0x000100FF

//    MSGDestroyConnection.dwDestroyReason

#define  SPR_DR_PROGRAM_EXIT                  0x00
#define  SPR_DR_DISABLED                      0x01
#define  SPR_DR_CONNECTIONERROR               0x02
#define  SPR_DR_SWITCHEDOFF                   0x03
#define  SPR_DR_DEVICEERROR                   0x04
#define  SPR_DR_UNKNOWN                       0xFF

//  

#define  SPR_RT_UNKNOWN                       0x0000
#define  SPR_RT_RECEIVED                      0x0001
#define  SPR_RT_DIALLED                       0x0002
#define  SPR_RT_MISSED                        0x0004
#define  SPR_RT_BYLEVEL                       0x0008
#define  SPR_RT_BYCOMMAND                     0x0010
#define  SPR_RT_VOICEMAIL                     0x0020
#define  SPR_RT_FRAGMENT                      0x0040

// DTMF - 

#define  SPR_DTMF_0                           0x00
#define  SPR_DTMF_1                           0x01
#define  SPR_DTMF_2                           0x02
#define  SPR_DTMF_3                           0x03
#define  SPR_DTMF_4                           0x04
#define  SPR_DTMF_5                           0x05
#define  SPR_DTMF_6                           0x06
#define  SPR_DTMF_7                           0x07
#define  SPR_DTMF_8                           0x08
#define  SPR_DTMF_9                           0x09
#define  SPR_DTMF_STAR                        0x0A
#define  SPR_DTMF_POUND                       0x0B
#define  SPR_DTMF_A                           0x0C
#define  SPR_DTMF_B                           0x0D
#define  SPR_DTMF_C                           0x0E
#define  SPR_DTMF_D                           0x0F
#define  SPR_DTMF_UNKNOWN                     0xFF


// InfoIndex  ISpRecordChannelClientW.GetInfo

#define  SPR_CHANNEL_INFO_CONVERSATIONACTIVE   0x00000001 // WordBool
#define  SPR_CHANNEL_INFO_CONVERSATIONDATETIME 0x00000002 // DateTime
#define  SPR_CHANNEL_INFO_CONVERSATIONLENG     0x00000003 // LONG
#define  SPR_CHANNEL_INFO_RECORDACTIVE         0x00000004 // WordBool
#define  SPR_CHANNEL_INFO_RECORDDATETIME       0x00000005 // DateTime
#define  SPR_CHANNEL_INFO_RECORDLENG           0x00000006 // LONG
#define  SPR_CHANNEL_INFO_PHONEFROM            0x00000007 // BSTR
#define  SPR_CHANNEL_INFO_SUBPHONEFROM         0x00000008 // BSTR
#define  SPR_CHANNEL_INFO_PHONETO              0x00000009 // BSTR
#define  SPR_CHANNEL_INFO_SUBPHONETO           0x0000000A // BSTR
#define  SPR_CHANNEL_INFO_RECORDTYPE           0x0000000B // LONG
#define  SPR_CHANNEL_INFO_FILENAME             0x0000000C // BSTR
#define  SPR_CHANNEL_INFO_RING                 0x0000000D // WordBool
#define  SPR_CHANNEL_INFO_RINGFIRSTDATETIME    0x0000000E // DateTime
#define  SPR_CHANNEL_INFO_RINGLENG             0x0000000F // LONG
#define  SPR_CHANNEL_INFO_RINGCOUNT            0x00000010 // LONG
#define  SPR_CHANNEL_INFO_HANDSETTAKEN         0x00000011 // WordBool
#define  SPR_CHANNEL_INFO_HANDSETTAKEDATETIME  0x00000012 // DateTime
#define  SPR_CHANNEL_INFO_HANDSETTAKELENG      0x00000013 // LONG

//  

#define  SPR_MAX_MSG_SIZE                     32768
#define  MAX_CHANNEL_NAME_CHARS               48
#define  MAX_PHONE_NUMBER_CHARS               48
#define  MAX_SUBPHONE_NUMBER_CHARS            24
#define  MAX_DEVICE_NAME_CHARS                64
#define  MAX_SEND_AUDIO_DATA_SIZE             SPR_MAX_MSG_SIZE - 12
#define  MAX_COMMENT_CHARS                    4096

#pragma pack(push, 1)

//  

typedef struct _MSGHEADER {
  DWORD dwMsgSize;
  DWORD dwMsg;
  DATE MsgTime;
} MSGHEADER, *PMSGHEADER, *LPMSGHEADER;

//    

typedef struct _MSGCHANNELNAME {
  MSGHEADER mh;            
  wchar_t cbChannelName[MAX_CHANNEL_NAME_CHARS];
} MSGCHANNELNAME, *PMSGCHANNELNAME, *LPMSGCHANNELNAME;

typedef struct _MSGRING {
  MSGHEADER mh;
  wchar_t cbChannelName[MAX_CHANNEL_NAME_CHARS];
  DWORD dwRingCount;
} MSGRING, *PMSGRING, *LPMSGRING;

typedef struct _MSGRECORDSTART {
  MSGHEADER mh;
  wchar_t cbChannelName[MAX_CHANNEL_NAME_CHARS];
  DWORD dwRecordType;
  wchar_t cbPhoneFrom[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneFrom[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbPhoneTo[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneTo[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbFileName[MAX_PATH];
} MSGRECORDSTART, *PMSGRECORDSTART, *LPMSGRECORDSTART;

typedef struct _MSGRECORDSTOP {
  MSGHEADER mh;                  
  wchar_t cbChannelName[MAX_CHANNEL_NAME_CHARS];
  DWORD dwRecordType;
  wchar_t cbPhoneFrom[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneFrom[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbPhoneTo[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneTo[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbFileName[MAX_PATH];
  DWORD dwLeng;
  BOOL NormalStop;
  BOOL bCompress;
} MSGRECORDSTOP, *PMSGRECORDSTOP, *LPMSGRECORDSTOP;

typedef struct _MSGPHONENUMBER {
  MSGHEADER mh;
  wchar_t cbChannelName[MAX_CHANNEL_NAME_CHARS];
  wchar_t cbPhoneNumber[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneNumber[MAX_SUBPHONE_NUMBER_CHARS];
} MSGPHONENUMBER, *PMSGPHONENUMBER, *LPMSGPHONENUMBER;

typedef struct _MSGMISSEDPHONE {
  MSGHEADER mh;
  wchar_t cbChannelName[MAX_CHANNEL_NAME_CHARS];
  wchar_t cbPhoneFrom[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneFrom[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbPhoneTo[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneTo[MAX_SUBPHONE_NUMBER_CHARS];
} MSGMISSEDPHONE, *PMSGMISSEDPHONE, *LPMSGMISSEDPHONE;

typedef struct _MSGRECORDTYPE {
  MSGHEADER mh;
  wchar_t cbChannelName[MAX_CHANNEL_NAME_CHARS];
  DWORD dwRecordType;
} MSGRECORDTYPE, *PMSGRECORDTYPE, *LPMSGRECORDTYPE;

typedef struct _MSGCHANGECHANNELNAME {
  MSGHEADER mh;
  wchar_t cbOldChannelName[MAX_CHANNEL_NAME_CHARS];
  wchar_t cbNewChannelName[MAX_CHANNEL_NAME_CHARS];
} MSGCHANGECHANNELNAME, *PMSGCHANGECHANNELNAME, *LPMSGCHANGECHANNELNAME;

typedef struct _MSGTEXT {
  MSGHEADER mh;
  wchar_t cbText[1];
} MSGTEXT, *PMSGTEXT, *LPMSGTEXT;

typedef struct _MSGDESTROYCONNECTION {
  MSGHEADER mh;
  DWORD dwDestroyReason;
} MSGDESTROYCONNECTION, *PMSGDESTROYCONNECTION, *LPMSGDESTROYCONNECTION;

typedef struct _MSGDEVICENAME {
  MSGHEADER mh;
  wchar_t cbDeviceName[MAX_DEVICE_NAME_CHARS];
} MSGDEVICENAME, *PMSGDEVICENAME, *LPMSGDEVICENAME;

typedef struct _MSGDEVICEDISCONNECT {
  MSGHEADER mh;
  wchar_t cbDeviceName[MAX_DEVICE_NAME_CHARS];
  DWORD dsDisconnectReason;
} MSGDEVICEDISCONNECT, *PMSGDEVICEDISCONNECT, *LPMSGDEVICEDISCONNECT;

typedef struct _MSGCOMPRESSINGFINISHED {
  MSGHEADER mh;
  wchar_t cbFileName[MAX_PATH];
} MSGCOMPRESSINGFINISHED, *PMSGCOMPRESSINGFINISHED, *LPMSGCOMPRESSINGFINISHED;

//    

typedef struct _CHANNELMSGRING {
  MSGHEADER mh;
  DWORD dwRingCount;
} CHANNELMSGRING, *PCHANNELMSGRING, *LPCHANNELMSGRING;

typedef struct _CHANNELMSGRECORDSTART {
  MSGHEADER mh;
  DWORD dwRecordType;
  wchar_t cbPhoneFrom[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneFrom[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbPhoneTo[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneTo[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbFileName[MAX_PATH];
} CHANNELMSGRECORDSTART, *PCHANNELMSGRECORDSTART, *LPCHANNELMSGRECORDSTART;

typedef struct _CHANNELMSGRECORDSTOP {
  MSGHEADER mh;
  DWORD dwRecordType;
  wchar_t cbPhoneFrom[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneFrom[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbPhoneTo[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneTo[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbFileName[MAX_PATH];
  DWORD dwLeng;
  BOOL NormalStop;
  BOOL bCompress;
} CHANNELMSGRECORDSTOP, *PCHANNELMSGRECORDSTOP, *LPCHANNELMSGRECORDSTOP;

typedef struct _CHANNELMSGPHONENUMBER {
  MSGHEADER mh;
  wchar_t cbPhoneNumber[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneNumber[MAX_SUBPHONE_NUMBER_CHARS];
} CHANNELMSGPHONENUMBER, *PCHANNELMSGPHONENUMBER, *LPCHANNELMSGPHONENUMBER;

typedef struct _CHANNELMSGMISSEDPHONE {
  MSGHEADER mh;
  wchar_t cbPhoneFrom[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneFrom[MAX_SUBPHONE_NUMBER_CHARS];
  wchar_t cbPhoneTo[MAX_PHONE_NUMBER_CHARS];
  wchar_t cbSubPhoneTo[MAX_SUBPHONE_NUMBER_CHARS];
} CHANNELMSGMISSEDPHONE, *PCHANNELMSGMISSEDPHONE, *LPCHANNELMSGMISSEDPHONE;

typedef struct _CHANNELMSGRECORDTYPE {
  MSGHEADER mh;
  DWORD dwRecordType;
} CHANNELMSGRECORDTYPE, *PCHANNELMSGRECORDTYPE, *LPCHANNELMSGRECORDTYPE;

typedef struct _CHANNELMSGDATA {
  MSGHEADER mh;
  DWORD dwDataSize;
  unsigned char cbData[1];
} CHANNELMSGDATA, *PCHANNELMSGDATA, *LPCHANNELMSGDATA;

typedef struct _CHANNELMSGDTMFCODE {
  MSGHEADER mh;
  DWORD dwDTMFCode;
} CHANNELMSGDTMFCODE, *PCHANNELMSGDTMFCODE, *LPCHANNELMSGDTMFCODE;

typedef struct _CHANNELMSGAUDIOBUFSTATE {
  MSGHEADER mh;
  DWORD dwMilliseconds;
} CHANNELMSGAUDIOBUFSTATE, *PCHANNELMSGAUDIOBUFSTATE, *LPCHANNELMSGAUDIOBUFSTATE;

#pragma pack(pop)

#endif
